#ifndef I2COscillator_h
#define I2COscillator_h

#include <Arduino.h>
#include "I2C.h"

class I2COscillator {
public:
    I2COscillator(I2C * _i2c, int _i2caddr, float _freq, byte _bitScale = 0);

    bool begin();
    
    float getRequestedFreq();
    float getActualFreq();
    float getMillisPerTick();
    float getMicrosPerTick();

private:
    int i2cAddress;
    I2C * theI2C;

    float requestedFreq;
    float actualFreq;
    byte bitScale;
};

#endif
