#ifndef InterruptManager_H
#define	InterruptManager_H

#include <Arduino.h>
#include "AbstractInterruptHandler.h"
#include "Map.h"

//template <class T>
class InterruptManager {
public:
    bool attachHandlerToPin(AbstractInterruptHandler * handler, byte pin, byte mode, bool pullup = false);
    void detachHandlerFromPin(byte pin);
    
    bool attachHandlerToInterrupt(AbstractInterruptHandler * handler, byte irNo, byte mode, bool pullup = false);
    void detachHandlerFromInterrupt(byte irNo);

    void handleInterrupt(byte pin);
    
    static InterruptManager * getManager();
    static void removeManager();

private:
    InterruptManager();

    byte getPinForIrNo(byte irNo);
    
    Map<byte, AbstractInterruptHandler *> * handlerMap = NULL;
};

extern InterruptManager interruptManager;

#endif
