#ifndef Number_H
#define Number_H

template <class T>
class Number {
public:
    Number() {
        val = 0;
    }
    
    Number(T _val) {
        val = _val;
    }
    
    T value() {
        return val;
    }

    Number& operator++() {
        ++val;
        return *this;
    }

    Number& operator+=(const Number& rhs) {
        val += rhs.val;
        return *this;
    }

    Number operator+(const Number& rhs) {
        Number t(*this);
        t += rhs;
        return t;
    }

    Number& operator--() {
        --val;
        return *this;
    }

    Number& operator-=(const Number& rhs) {
        val -= rhs.val;
        return *this;
    }

    Number operator-(const Number& rhs) {
        Number t(*this);
        t -= rhs;
        return t;
    }

    Number& operator*=(const Number& rhs) {
        val *= rhs.val;
        return *this;
    }

    Number operator*(const Number& rhs) {
        Number t(*this);
        t *= rhs;
        return t;
    }

    Number& operator/=(const Number& rhs) {
        val /= rhs.val;
        return *this;
    }

    Number operator/(const Number& rhs) {
        Number t(*this);
        t /= rhs;
        return t;
    }

    bool operator==(const Number<T>& rhs) {
        return val == rhs.val;
    }
    
    bool operator!=(const Number<T>& rhs) {
        return val != rhs.val;
    }
    
    bool operator<(const Number<T>& rhs) {
        return val < rhs.val;
    }
    
    bool operator<=(const Number<T>& rhs) {
        return val <= rhs.val;
    }
    
    bool operator>(const Number<T>& rhs) {
        return val > rhs.val;
    }
    
    bool operator>=(const Number<T>& rhs) {
        return val >= rhs.val;
    }
    
    int compareTo(const Number<T>& rhs) {
        if (val < rhs.val) {
            return -1;
        }
        if (val == rhs.val) {
            return 0;
        }
        return 1;
    }

private:
    T val;
};

typedef Number<byte> Byte;
typedef Number<int> Int;
typedef Number<unsigned int> UInt;
typedef Number<word> Word;
typedef Number<long> Long;
typedef Number<unsigned long> ULong;
typedef Number<short> Short;
typedef Number<float> Float;
typedef Number<double> Double;

#endif
