#ifndef Timer_h
#define Timer_h

#include "AbstractInterruptHandler.h"

class Timer : public AbstractInterruptHandler {
public:
    Timer(byte _pin);
    
    bool start();
    void stop();
    
    bool isOk();
    
    void handleInterrupt(byte intPin);
    
    void onAttach(byte intPin);

    void onDetach(byte intPin);
    
    long getLastTickCount();
    long getLastTickTimeMS();

private:
    byte pin;
    
    long lastTickCount;
    long lastTickTimeMS;
    
    bool isAttached;
};

#endif
